import time
from neopixel import Neopixel
from machine import Pin
pixels = Neopixel(15, 0, 3, "GRB")


p0 = Pin(26, Pin.OUT)
p1 = Pin(27, Pin.OUT)
p2 = Pin(28, Pin.OUT)
button = Pin(4, Pin.IN, Pin.PULL_DOWN)
pixel_index = 0
color_index = 0
z = 0
x = 0
colors = [
  [(66, 209, 224),
(255, 0, 0), (120, 30, 254), (47, 249, 36), (255, 59, 0), (255, 255, 0)],
(0, 0, 0)]
p0.value(1)
p1.value(1)
p2.value(1)

def on():
 global p0
 global p1
 global p2
 global x
 global pixels
 global pixel_index
 global colors
 global z
 b = 0.18
 while pixel_index < 15:
     pixels.set_pixel(pixel_index, colors[0][z])
     pixels.show()
     #print(pixel_index, colors[color_index])
     pixel_index += 1
     time.sleep(b)
     if b > 0.1:
        b -= 0.08
     elif b > 0.05:
        b -= 0.08
 if pixel_index == 15:
     x = 1
     p1.value(1)
     return
     

def off():
 global p1
 global p2
 global p0
 global x
 global pixels 
 global pixel_index
 global colors
 global z
 b = 0.12
 pixel_index = 14
 while pixel_index >= 0:
     pixels.set_pixel(pixel_index, colors[1])
     pixels.show()
     #print(pixel_index, colors[color_index])
     pixel_index -= 1
     time.sleep(b)
     if b > 0.1:
        b -= 0.01
     elif b > 0.05:
        b -= 0.07
 if pixel_index < 0:
     pixel_index = 0
     x = 0
     return
    

while True:
  if button.value():
     if x == 0:
         print("On")
         time.sleep(0.2)
         on()
     elif x == 1:
         z += 1
         if z == 6:
            z = 0
         print("Off")
         time.sleep(0.2)
         off()